from buf.validate import validate_pb2 as _validate_pb2
from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from collections.abc import Iterable as _Iterable, Mapping as _Mapping
from typing import ClassVar as _ClassVar, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class FileType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    FILE_TYPE_UNSPECIFIED: _ClassVar[FileType]
    FILE_TYPE_DOCUMENT: _ClassVar[FileType]
    FILE_TYPE_IMAGE: _ClassVar[FileType]
    FILE_TYPE_VIDEO: _ClassVar[FileType]
    FILE_TYPE_AUDIO: _ClassVar[FileType]
    FILE_TYPE_ARCHIVE: _ClassVar[FileType]
    FILE_TYPE_CODE: _ClassVar[FileType]
    FILE_TYPE_OTHER: _ClassVar[FileType]

class FileStatus(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    FILE_STATUS_UNSPECIFIED: _ClassVar[FileStatus]
    FILE_STATUS_UPLOADING: _ClassVar[FileStatus]
    FILE_STATUS_ACTIVE: _ClassVar[FileStatus]
    FILE_STATUS_PROCESSING: _ClassVar[FileStatus]
    FILE_STATUS_ARCHIVED: _ClassVar[FileStatus]
    FILE_STATUS_DELETED: _ClassVar[FileStatus]
FILE_TYPE_UNSPECIFIED: FileType
FILE_TYPE_DOCUMENT: FileType
FILE_TYPE_IMAGE: FileType
FILE_TYPE_VIDEO: FileType
FILE_TYPE_AUDIO: FileType
FILE_TYPE_ARCHIVE: FileType
FILE_TYPE_CODE: FileType
FILE_TYPE_OTHER: FileType
FILE_STATUS_UNSPECIFIED: FileStatus
FILE_STATUS_UPLOADING: FileStatus
FILE_STATUS_ACTIVE: FileStatus
FILE_STATUS_PROCESSING: FileStatus
FILE_STATUS_ARCHIVED: FileStatus
FILE_STATUS_DELETED: FileStatus

class File(_message.Message):
    __slots__ = ("id", "context", "name", "file_type", "content_type", "size_bytes", "checksum", "created", "updated", "metadata", "storage_url", "status")
    ID_FIELD_NUMBER: _ClassVar[int]
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    FILE_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    CHECKSUM_FIELD_NUMBER: _ClassVar[int]
    CREATED_FIELD_NUMBER: _ClassVar[int]
    UPDATED_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    STORAGE_URL_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    id: str
    context: str
    name: str
    file_type: FileType
    content_type: str
    size_bytes: int
    checksum: str
    created: _timestamp_pb2.Timestamp
    updated: _timestamp_pb2.Timestamp
    metadata: _struct_pb2.Struct
    storage_url: str
    status: FileStatus
    def __init__(self, id: _Optional[str] = ..., context: _Optional[str] = ..., name: _Optional[str] = ..., file_type: _Optional[_Union[FileType, str]] = ..., content_type: _Optional[str] = ..., size_bytes: _Optional[int] = ..., checksum: _Optional[str] = ..., created: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., updated: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., metadata: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., storage_url: _Optional[str] = ..., status: _Optional[_Union[FileStatus, str]] = ...) -> None: ...

class FileFilter(_message.Message):
    __slots__ = ("names", "ids", "file_types", "context", "created_after", "created_before", "updated_after", "updated_before", "status", "content_type_prefix", "min_size_bytes", "max_size_bytes", "prefix", "content_type")
    NAMES_FIELD_NUMBER: _ClassVar[int]
    IDS_FIELD_NUMBER: _ClassVar[int]
    FILE_TYPES_FIELD_NUMBER: _ClassVar[int]
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    CREATED_AFTER_FIELD_NUMBER: _ClassVar[int]
    CREATED_BEFORE_FIELD_NUMBER: _ClassVar[int]
    UPDATED_AFTER_FIELD_NUMBER: _ClassVar[int]
    UPDATED_BEFORE_FIELD_NUMBER: _ClassVar[int]
    STATUS_FIELD_NUMBER: _ClassVar[int]
    CONTENT_TYPE_PREFIX_FIELD_NUMBER: _ClassVar[int]
    MIN_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    MAX_SIZE_BYTES_FIELD_NUMBER: _ClassVar[int]
    PREFIX_FIELD_NUMBER: _ClassVar[int]
    CONTENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    names: _containers.RepeatedScalarFieldContainer[str]
    ids: _containers.RepeatedScalarFieldContainer[str]
    file_types: _containers.RepeatedScalarFieldContainer[FileType]
    context: str
    created_after: _timestamp_pb2.Timestamp
    created_before: _timestamp_pb2.Timestamp
    updated_after: _timestamp_pb2.Timestamp
    updated_before: _timestamp_pb2.Timestamp
    status: FileStatus
    content_type_prefix: str
    min_size_bytes: int
    max_size_bytes: int
    prefix: str
    content_type: str
    def __init__(self, names: _Optional[_Iterable[str]] = ..., ids: _Optional[_Iterable[str]] = ..., file_types: _Optional[_Iterable[_Union[FileType, str]]] = ..., context: _Optional[str] = ..., created_after: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., created_before: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., updated_after: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., updated_before: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., status: _Optional[_Union[FileStatus, str]] = ..., content_type_prefix: _Optional[str] = ..., min_size_bytes: _Optional[int] = ..., max_size_bytes: _Optional[int] = ..., prefix: _Optional[str] = ..., content_type: _Optional[str] = ...) -> None: ...

class FileResult(_message.Message):
    __slots__ = ("file", "error")
    FILE_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    file: File
    error: str
    def __init__(self, file: _Optional[_Union[File, _Mapping]] = ..., error: _Optional[str] = ...) -> None: ...

class UploadFileData(_message.Message):
    __slots__ = ("context", "name", "file_type", "content_type", "content", "metadata", "replace_if_exists")
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    FILE_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    REPLACE_IF_EXISTS_FIELD_NUMBER: _ClassVar[int]
    context: str
    name: str
    file_type: FileType
    content_type: str
    content: bytes
    metadata: _struct_pb2.Struct
    replace_if_exists: bool
    def __init__(self, context: _Optional[str] = ..., name: _Optional[str] = ..., file_type: _Optional[_Union[FileType, str]] = ..., content_type: _Optional[str] = ..., content: _Optional[bytes] = ..., metadata: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ..., replace_if_exists: bool = ...) -> None: ...

class UploadFilesRequest(_message.Message):
    __slots__ = ("files",)
    FILES_FIELD_NUMBER: _ClassVar[int]
    files: _containers.RepeatedCompositeFieldContainer[UploadFileData]
    def __init__(self, files: _Optional[_Iterable[_Union[UploadFileData, _Mapping]]] = ...) -> None: ...

class UploadFilesResponse(_message.Message):
    __slots__ = ("results", "total_uploaded", "total_failed")
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    TOTAL_UPLOADED_FIELD_NUMBER: _ClassVar[int]
    TOTAL_FAILED_FIELD_NUMBER: _ClassVar[int]
    results: _containers.RepeatedCompositeFieldContainer[FileResult]
    total_uploaded: int
    total_failed: int
    def __init__(self, results: _Optional[_Iterable[_Union[FileResult, _Mapping]]] = ..., total_uploaded: _Optional[int] = ..., total_failed: _Optional[int] = ...) -> None: ...

class ListFilesRequest(_message.Message):
    __slots__ = ("filter", "list_size", "offset", "order")
    FILTER_FIELD_NUMBER: _ClassVar[int]
    LIST_SIZE_FIELD_NUMBER: _ClassVar[int]
    OFFSET_FIELD_NUMBER: _ClassVar[int]
    ORDER_FIELD_NUMBER: _ClassVar[int]
    filter: FileFilter
    list_size: int
    offset: int
    order: str
    def __init__(self, filter: _Optional[_Union[FileFilter, _Mapping]] = ..., list_size: _Optional[int] = ..., offset: _Optional[int] = ..., order: _Optional[str] = ...) -> None: ...

class ListFilesResponse(_message.Message):
    __slots__ = ("files", "total_count")
    FILES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_COUNT_FIELD_NUMBER: _ClassVar[int]
    files: _containers.RepeatedCompositeFieldContainer[File]
    total_count: int
    def __init__(self, files: _Optional[_Iterable[_Union[File, _Mapping]]] = ..., total_count: _Optional[int] = ...) -> None: ...

class GetFileRequest(_message.Message):
    __slots__ = ("context", "id", "name", "include_content")
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    ID_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_CONTENT_FIELD_NUMBER: _ClassVar[int]
    context: str
    id: str
    name: str
    include_content: bool
    def __init__(self, context: _Optional[str] = ..., id: _Optional[str] = ..., name: _Optional[str] = ..., include_content: bool = ...) -> None: ...

class GetFileResponse(_message.Message):
    __slots__ = ("file", "content")
    FILE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    file: File
    content: bytes
    def __init__(self, file: _Optional[_Union[File, _Mapping]] = ..., content: _Optional[bytes] = ...) -> None: ...

class UpdateFileRequest(_message.Message):
    __slots__ = ("context", "name", "new_name", "file_type", "content_type", "content", "metadata")
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    NEW_NAME_FIELD_NUMBER: _ClassVar[int]
    FILE_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_TYPE_FIELD_NUMBER: _ClassVar[int]
    CONTENT_FIELD_NUMBER: _ClassVar[int]
    METADATA_FIELD_NUMBER: _ClassVar[int]
    context: str
    name: str
    new_name: str
    file_type: FileType
    content_type: str
    content: bytes
    metadata: _struct_pb2.Struct
    def __init__(self, context: _Optional[str] = ..., name: _Optional[str] = ..., new_name: _Optional[str] = ..., file_type: _Optional[_Union[FileType, str]] = ..., content_type: _Optional[str] = ..., content: _Optional[bytes] = ..., metadata: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ...) -> None: ...

class UpdateFileResponse(_message.Message):
    __slots__ = ("result",)
    RESULT_FIELD_NUMBER: _ClassVar[int]
    result: FileResult
    def __init__(self, result: _Optional[_Union[FileResult, _Mapping]] = ...) -> None: ...

class FileIdentifier(_message.Message):
    __slots__ = ("ids", "names", "prefix")
    IDS_FIELD_NUMBER: _ClassVar[int]
    NAMES_FIELD_NUMBER: _ClassVar[int]
    PREFIX_FIELD_NUMBER: _ClassVar[int]
    ids: _containers.RepeatedScalarFieldContainer[str]
    names: _containers.RepeatedScalarFieldContainer[str]
    prefix: str
    def __init__(self, ids: _Optional[_Iterable[str]] = ..., names: _Optional[_Iterable[str]] = ..., prefix: _Optional[str] = ...) -> None: ...

class GetFilesRequest(_message.Message):
    __slots__ = ("context", "filter", "list_size", "offset", "order", "include_content")
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    LIST_SIZE_FIELD_NUMBER: _ClassVar[int]
    OFFSET_FIELD_NUMBER: _ClassVar[int]
    ORDER_FIELD_NUMBER: _ClassVar[int]
    INCLUDE_CONTENT_FIELD_NUMBER: _ClassVar[int]
    context: str
    filter: FileIdentifier
    list_size: int
    offset: int
    order: str
    include_content: bool
    def __init__(self, context: _Optional[str] = ..., filter: _Optional[_Union[FileIdentifier, _Mapping]] = ..., list_size: _Optional[int] = ..., offset: _Optional[int] = ..., order: _Optional[str] = ..., include_content: bool = ...) -> None: ...

class GetFilesResponse(_message.Message):
    __slots__ = ("files", "total_count")
    FILES_FIELD_NUMBER: _ClassVar[int]
    TOTAL_COUNT_FIELD_NUMBER: _ClassVar[int]
    files: _containers.RepeatedCompositeFieldContainer[File]
    total_count: int
    def __init__(self, files: _Optional[_Iterable[_Union[File, _Mapping]]] = ..., total_count: _Optional[int] = ...) -> None: ...

class DeleteFilesRequest(_message.Message):
    __slots__ = ("context", "filter", "force", "permanent")
    CONTEXT_FIELD_NUMBER: _ClassVar[int]
    FILTER_FIELD_NUMBER: _ClassVar[int]
    FORCE_FIELD_NUMBER: _ClassVar[int]
    PERMANENT_FIELD_NUMBER: _ClassVar[int]
    context: str
    filter: FileIdentifier
    force: bool
    permanent: bool
    def __init__(self, context: _Optional[str] = ..., filter: _Optional[_Union[FileIdentifier, _Mapping]] = ..., force: bool = ..., permanent: bool = ...) -> None: ...

class DeleteFilesResponse(_message.Message):
    __slots__ = ("results", "total_deleted", "total_failed")
    class ResultsEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: bool
        def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
    RESULTS_FIELD_NUMBER: _ClassVar[int]
    TOTAL_DELETED_FIELD_NUMBER: _ClassVar[int]
    TOTAL_FAILED_FIELD_NUMBER: _ClassVar[int]
    results: _containers.ScalarMap[str, bool]
    total_deleted: int
    total_failed: int
    def __init__(self, results: _Optional[_Mapping[str, bool]] = ..., total_deleted: _Optional[int] = ..., total_failed: _Optional[int] = ...) -> None: ...
